<?php

namespace Form;

use Symfony\Component\HttpFoundation\Request;

/**
 *
 */
trait FormValidatorTrait
{
    /**
     * {@inheritdoc}
     */
    public function handle(Request $request)
    {
        $errors = array_reduce(
            $this->getFields(),
            function (array $errors, FieldValidatorInterface $renderableField) use ($request) {
                $fieldErrors = $renderableField->isValid($request);

                if (!empty($fieldErrors)) {
                    $errors[$renderableField->getName()] = $fieldErrors;
                }

                return $errors;
            },
            []
        );

        return $errors;
    }

    /**
     * @return FieldValidatorInterface[]
     */
    abstract protected function getFields();
}
